;This program is "Backup," a tool for backingup programs

;Include file needed to access system routines
 include "ti83plus.inc"

EXT_APP equ 1   ;This definition is required of all apps
cseg            ;This linker directive is required of all apps.

;This is the application header definition area required for all apps.
 db 080h,0Fh    ;Field: Program length
 db   00h,00h,00h,00h ;Length=0 (N/A for unsigned apps)
 db 080h,012h    ;Field: Program type
 db   01h,04h  ;Type= Shareware, TI-83Plus
 db 080h,021h    ;Field: App ID
 db   01h       ;Id = 1
 db 080h,031h    ;Field: App Build
 db   01h       ;Build = 1
 db 080h,048h    ;Field: App Name
 db 042h,061h,063h,06bh,075h,070h,020h,020h ;Name = "Backup  " must be 8 characters
 db 080h,081h    ;Field: App Pages
 db 01h         ;App Pages = 1
 db 080h,090h    ;No default splash screen
 db 03h,026h ,09h,04h, 04h,06fh,01bh,80h     ;Field: Date stamp- 5/12/1999
 db 02h,0dh,040h                             ;Dummy encrypted TI date stamp signature
 db 0a1h ,06bh ,099h ,0f6h ,059h ,0bch ,067h 
 db 0f5h ,085h ,09ch ,09h ,06ch ,0fh ,0b4h ,03h ,09bh ,0c9h 
 db 03h ,032h ,02ch ,0e0h ,03h ,020h ,0e3h ,02ch ,0f4h ,02dh 
 db 073h ,0b4h ,027h ,0c4h ,0a0h ,072h ,054h ,0b9h ,0eah ,07ch 
 db 03bh ,0aah ,016h ,0f6h ,077h ,083h ,07ah ,0eeh ,01ah ,0d4h 
 db 042h ,04ch ,06bh ,08bh ,013h ,01fh ,0bbh ,093h ,08bh ,0fch 
 db 019h ,01ch ,03ch ,0ech ,04dh ,0e5h ,075h 
 db 80h,7Fh      ;Field: Program Image length
 db   0,0,0,0    ;Length=0, N/A
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved



;Program Start  
Menu:
  B_CALL ClrLCDFull        ;Clear the screen
  res onInterrupt,(IY+onFlags)
  res indicOnly,(IY+indicFlags)
  B_CALL CanAlphIns
  B_CALL ZeroOP1
  B_CALL ZeroOP2
  B_CALL ZeroOP3
  ld hl,OP4
  B_CALL ZeroOP
  ld hl,OP5
  B_CALL ZeroOP
  ld hl,OP6
  B_CALL ZeroOP        ;Zero all operands, reset alpha lock and second
;Displays Menu
  ld a,0               ;A=0
  ld (curCol),a        ;Will start printing in column 0
  ld (curRow),a        ;Will start printing on row 0
  ld hl, SHeader       ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS          ;Print the string
  ld hl, SHeader2      ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS          ;Print the string
  ld a,1               ;A=1
  ld (curRow),a        ;Will start printing on row 1
  ld a,0               ;A=0
  ld (curCol),a        ;Will start printing in column 0
  ld hl, SMenu1        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS          ;Print the string
  ld a,2               ;A=2
  ld (curRow),a        ;Will start printing on row 2
  ld a,0               ;A=0
  ld (curCol),a        ;Will start printing in column 0
  ld hl, SMenu2        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS          ;Print the string
  ld a,3               ;A=3
  ld (curRow),a        ;Will start printing on row 3
  ld a,0               ;A=0
  ld (curCol),a        ;Will start printing in column 0
  ld hl, SMenu3        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS          ;Print the string
  jr GetMenuKey        ;jump to Menu Key reader
GetMenuKey:
  res onInterrupt,(IY+onFlags)
  B_CALL GetKey        ;Wait for key press
  ld de,0008F          ;Load 1 into DE
  ld l,a               ;Load Key into HL
  ld h,0  
  B_CALL CpHLDE        ;Compare DE,HL
  jr Z, BackUp         ;If key = 1 jump to Backup
  ld de,0090h          ;Load 2 into DE
  ld l,a               ;Load Key into HL
  ld h,0
  B_CALL CpHLDE        ;Compare DE,HL
  jr Z, Restore        ;If key = 2 jump to Restore
  ld de,0091h          ;Load 3 into DE
  ld l,a               ;Load Key into HL
  ld h,0
  B_CALL CpHLDE        ;Compare DE,HL
  jr Z, ExitApp        ;If key = 3 jump to ExitApp
  jr NZ, GetMenuKey    ;If key press invalid repole for key

;displays backup prompt
BackUp:
  B_CALL ClrLCDFull        ;Clear the screen  
  ld a,0                   ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld (curRow),a            ;Will start printing on first row
  ld hl, SNameOfPro        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS              ;Print the string
  ld hl, Sgram             ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS              ;Print the string
  ld a,0                   ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld a,1
  ld (curRow),a            ;Will start printing on row 2
  ld hl, StoBackUp         ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS              ;Print the string
  ld a,0                   ;A=0
  ld (curCol),a            ;Will start printing in left column
  jp NameLoop1
;Loop to enter name
NameLoop1:
  set shiftALock,(IY+shiftFlags)  
  ld a,2
  ld (curRow),a            ;Will start printing on row 3
  B_CALL GetKey            ;Wait for key press
  ld l,a                   ;load hl with key code
  ld h,0
  push hl                  ;save key code
  ld de,005h               ;de = Enter Key 1
  B_CALL CpHLDE            ;Check if Enter Key 1
  jr Z,FindProgram         ;End Name Loop if done
  ld de,000Dh              ;de = Enter Key 2
  B_CALL CpHLDE            ;Check if Enter Key 2
  jr Z,FindProgram         ;End Name Loop if done
  B_CALL SetXXXXOP2        ;key code to OP2
  B_CALL OP2ToOP1          ;OP1 = OP2
  ld hl,0059h              ;load difference of key code letters and character code letters
  B_CALL SetXXXXOP2
  B_CALL FPSub             ;convert keycode to character code
  pop hl                   ;restore keycode
  ld de,0098h              ;Load split between numbers and letters
  B_CALL CpHLDE            ;determine if numbers or letter
  jr NC,KeyConverted       ;if letters go to key converted
  ld hl,0005h
  B_CALL SetXXXXOP2        ;OP2 = difference b conversion to numbers
  B_CALL FPSub             ;adjust to numbers
;displays key and stores name in OP4
KeyConverted:
  B_CALL ConvOP1           ;de = character code
  ld a,e                   ;a = character code
  B_CALL PutMap            ;displays character code
  push de                  ;save character code
  B_CALL OP3ToOP1
  B_CALL Plus1
  B_CALL OP1ToOP3          ;increments OP3(Current Letter)
  B_CALL ConvOP1           ;Current current letter to De
  Pop bc                   ;Restore character code to Bc
  ld hl,0001h              ;1 to hl          
  B_CALL CpHLDE            ;compare
  jr NZ, skip1             ;skip if not
  ld (OP4+1),bc            ;load OP4(name) with character code at current letter + 1
skip1:
  ld hl,0002h              ;2 to hl          
  B_CALL CpHLDE            ;compare
  jr NZ, skip2             ;skip if not
  ld (OP4+2),bc            ;load OP4(name) with character code at current letter + 1
skip2:
  ld hl,0003h              ;3 to hl          
  B_CALL CpHLDE            ;compare
  jr NZ, skip3             ;skip if not
  ld (OP4+3),bc            ;load OP4(name) with character code at current letter + 1Skip3:
skip3:
  ld hl,0004h              ;4 to hl          
  B_CALL CpHLDE            ;compare
  jr NZ, skip4             ;skip if not
  ld (OP4+4),bc            ;load OP4(name) with character code at current letter + 1
skip4:
  ld hl,0005h              ;5 to hl          
  B_CALL CpHLDE            ;compare
  jr NZ, skip5             ;skip if not
  ld (OP4+5),bc            ;load OP4(name) with character code at current letter + 1
skip5:
  ld hl,0006h              ;6 to hl          
  B_CALL CpHLDE            ;compare
  jr NZ, skip6             ;skip if not
  ld (OP4+6),bc            ;load OP4(name) with character code at current letter + 1
skip6:
  ld hl,0007h              ;7 to hl          
  B_CALL CpHLDE            ;compare
  jr NZ, skip7             ;skip if not
  ld (OP4+7),bc            ;load OP4(name) with character code at current letter + 1
skip7:
  ld hl,0008h              ;8 to hl          
  B_CALL CpHLDE            ;compare
  jr NZ, skip8             ;skip if not
  ld (OP4+8),bc            ;load OP4(name) with character code at current letter + 1
  jr Z,FindProgram         ;Jump out if 8
skip8:
  ld a,(curCol)
  inc a
  ld (curCol),a            ;increments cursor
  jp NameLoop1             ;returns for another key
;Locates Program if exists
FindProgram:
  B_CALL OP4ToOP1          ;loads OP1 with program name 
  ld a,05h
  ld (OP1+0),a             ;makes OP1 signify a program 
  B_CALL ChkFindSym        ;looks for program, determines if it is protected or not 
  jr C,TryAgain            ;if not found go to alternate search routine
ProgramFound:
  ld a,b
  or a                      ;check if program archived
  jr NZ,ProgramArchived     ;go to error for program archived
  B_CALL OP1ToOP6           ;store program name in OP6
  Call WhichOne             ;where to place backup in OP5,OP1
  B_CALL ChkFindSym         ;find appvar if exists
  jr C,CheckMemory          ;if appvar doesn't exist skip delete appvar
  B_CALL DelVarArc          ;delete appvar if it exists
CheckMemory:
  call ProgramBackUpSize    ;determine the size of the data to back up
  ld h,d
  ld l,e                    ;hl = size of program
  B_CALL SetXXXXOP2
  B_CALL OP2ToOP1           ;OP1 = size of program
  ld hl,000F                ;15 bytes for symbol table entry for appvar
  B_CALL SetXXXXOP2
  B_CALL FPAdd              ;Add 15 bytes for symbol table entry
  B_CALL ConvOP1
  ld h,d
  ld l,e                    ;memory required = hl
  B_CALL EnoughMem          ;check tha enough memory exists
  jr C,NotEnoughMem         ;jump to error handler if not enough memory
;creates appvar
CreateAppVar:
  call ProgramBackUpSize  ;determine the size of the data to back up
  push de                 ;save size of data
  B_CALL OP5ToOP1         ;AppVar name to OP1
  pop hl                  ;restore size of data
  ld de,0003h
  ADD HL,DE               ;+1 for valid data flag, +2 for data size
  B_CALL CreateAppVar
AddDataToAppVar:
  ld hl,0003h
  ADD HL,DE               ;+1 for valid data flag, +2 for data size
  ld d,h
  ld e,l                  ;de = hl
  push de                 ;save start of app var
  ld hl,AppVar4byteId     ;where data starts
  ld bc,4                 ;how many
  ldir                    ;load App Var Id into App Var
  pop de                  ;restore where data starts
  ld hl,0004h
  ADD HL,DE               ;+4 for id
  ld d,h
  ld e,l                  ;de = hl
  push de                 ;save start of app var + 4
  ld hl,OP6               ;program name
  ld bc,9                 ;how many
  ldir                    ;load ProgramName into App Var
  pop de                  ;restore start of app var + 4
  ld hl,0009h
  ADD HL,DE               ;+9 for program name  
  ld d,h
  ld e,l                  ;de = hl  
  push de                 ;save start of program
  B_CALL OP6ToOP1         ;program name to OP1
  B_CALL ChkFindSym       ;find program
  ld h,d
  ld l,e                  ;program's data pointer to hl
  ld a,(OP1+0)            ;program's data type to a
  B_CALL DataSize         ;hl = program's data pointer (de = data size)
  ld b,d
  ld c,e                  ;bc = datasize
  pop de                  ;de = App Var data start + 16
  ldir                    ;load program data into App Var
ArchiveAppVar:
  B_CALL OP5ToOP1         ;App Var Name to OP1
  B_CALL Chk_Batt_Low     ;Check if batteries are low
  jr Z,BattsLow           ;jump out if batteries low
  ld hl, DeleteAppVar     ;load place to jump to if an error occurs
  Call APP_PUSH_ERRORH    ;catch errors, if found go to DeleteAppVar
  B_CALL Arc_Unarc        ;archive AppVar
  CALL APP_POP_ERRORH     ;remove error handler
  jp Menu                 ;done
;cleans app var out of ram if it can't be archived
DeleteAppVar:
  B_CALL OP5ToOP1         ;App Var Name to OP1
  B_CALL ChkFindSym       ;find variable
  B_CALL DelVar           ;delete variable
  jp NotEnoughMem         ;go to error handler

;determines size of data to back up
ProgramBackUpSize:
  B_CALL OP6ToOP1       ;program to back up to OP1
  B_CALL ChkFindSym     ;find program
  ld a,(OP1+0)          ;load a with data type
  ld h,d
  ld l,e                ;data pointer to hl
  B_CALL DataSize       ;get size of program
  ld h,d
  ld l,e                ;data size to hl
  B_CALL SetXXXXOP2
  B_CALL OP2ToOP1       ;OP1 = data size
  ld hl,000Dh           ;+13 for data header + 4 Id + 9 name
  B_CALL SetXXXXOP2
  B_CALL FPAdd          ;add 13 for data header, 4 Id,  9 name
  B_CALL ConvOP1        ;data size to back up to de
  ret

WhichOne:
  B_CALL ClrLCDFull        ;clear the screen
  B_CALL ZeroOP1
  B_CALL ZeroOP2           ;zero OP1 and OP2
  ld a,0                   ;A=0
  ld (curCol),a            ;will start printing in left column
  ld (curRow),a            ;will start printing on first row  
  ld a,'1'
  B_CALL PutC              ;print character
  ld a,'.'
  B_CALL PutC              ;print character
  ld hl,RomBkup1           ;hl = pointer to app var 1 data
  CALL IdAppVar
  B_CALL NewLine
  ld a,'2'
  B_CALL PutC              ;print character
  ld a,'.'
  B_CALL PutC              ;print character    
  ld hl,RomBkup2           ;hl = pointer to app var 2 data
  CALL IdAppVar 
  B_CALL NewLine
  ld a,'3'
  B_CALL PutC              ;print character
  ld a,'.'
  B_CALL PutC              ;print character   
  ld hl,RomBkup3           ;hl = pointer to app var 3 data
  CALL IdAppVar            ;check for app var
  B_CALL NewLine
  ld a,'4'
  B_CALL PutC              ;print character
  ld a,'.'
  B_CALL PutC              ;print character    
  ld hl,RomBkup4           ;hl = pointer to app var 4 data
  CALL IdAppVar            ;check for app var 
  B_CALL NewLine           ;go to new line
  ld a,'5'
  B_CALL PutC              ;print character
  ld a,'.'
  B_CALL PutC              ;print character    
  ld hl,RomBkup5           ;hl = pointer to app var 5 data
  CALL IdAppVar            ;check for app var 
  B_CALL NewLine           ;go to new line  
  ld a,'6'
  B_CALL PutC              ;print character
  ld a,'.'
  B_CALL PutC              ;print character    
  ld hl,RomBkup6           ;hl = pointer to app var 6 data
  CALL IdAppVar            ;check for app var 
  B_CALL NewLine           ;go to new line
  ld a,'7'
  B_CALL PutC              ;print character
  ld a,'.'
  B_CALL PutC              ;print character    
  ld hl,RomBkup7           ;hl = pointer to app var 7 data
  CALL IdAppVar            ;check for app var 
  B_CALL NewLine           ;go to new line
  ld a,'8'
  B_CALL PutC              ;print character
  ld a,'.'
  B_CALL PutC              ;print character 
  ld hl,RomBkup8           ;hl = pointer to app var 8 data
  CALL IdAppVar            ;check for app var
  CALL GetKeyLoop          ;get app var
  ret
GetKeyLoop:
  B_CALL CanAlphIns        ;reset alpha lock and inserts
  B_CALL GetKey            ;wait for key press
  ld l,a
  ld h,0                   ;hl = keypress
  B_CALL SetXXXXOP2
  B_CALL OP2ToOP1          ;OP1 = keypress
  ld h,0
  ld l,0005Eh
  B_CALL SetXXXXOP2        ;OP2 = difference of key code numbers and character code numbers
  B_CALL FPSub             ;convert keycode to character code
  B_CALL OP1ToOP2          ;OP2 = character code
  ld hl,RomBkup1
  B_CALL Mov9ToOP1         ;OP1 = appvar 1
  B_CALL OP1ExOP2          ;switch OP1 and OP2
  B_CALL ConvOP1           ;de =  character code
  ld hl,30h                ;hl = 30 (1)
  B_CALL CpHLDE            ;compare character code and 1
  jr NC,GetKeyLoop         ;jump if key less than 30 (1)
  jr Z,GetKeyLoop          ;jump if key = 30 (1)
  ld hl,39h                ;hl = 30 (10)
  B_CALL CpHLDE            ;compare character code and 10
  jr C,GetKeyLoop          ;jump if key greater than 39 (10)
  jr Z,GetKeyLoop          ;jump if key = 39 (10)
  ld (OP2+8),de            ;load AppVar Number to end of AppVar Name (convert appvar1 to user selected app var)
  B_CALL OP2ToOP1          ;AppVar name to OP1
  B_CALL OP1ToOP5          ;AppVar name to OP5
  ret
  
IdAppVar:
  B_CALL Mov9ToOP1         ;OP1 = App var
  B_CALL ChkFindSym        ;find app var
  RET C                    ;return if doesn't exist
  ld a,b
  or a
  jr Z,InRam               ;jump if in Ram
  ld h,d
  ld l,e                   ;hl = start of variable
  ld de,15h                ;3 bytes + 15 bytes for symbol table entry + 3 bytes
  CALL AddHLDERom          ;calculate page and offset
  ld a,b                   ;a = archive page
  ld c,a                   ;c = archive page
  push hl                  ;save start of app var data
  push bc                  ;save archive status 
  ld de,OP1                ;load into OP1
  ld bc,4                  ;load 4 bytes
  B_CALL FlashToRam        ;first 4 bytes of data
  Call CheckValidVar       ;check if app var is valid
  pop bc                   ;restore archive status
  ld b,c                   ;b = archive page
  pop hl                   ;restore start of app var data
  ld de,0005h              ;4 byte id + 1 byte data type
  CALL AddHLDERom          ;calculate page and offset
  ld a,b                   ;load page into a
  ld de,OP1                ;load into OP1
  ld bc,8                  ;copy 8 bytes
  B_CALL FlashToRam        ;next 8 bytes of data (name)
  ld hl,OP1                ;hl = pointer to OP1
  ld a,0
  ld (OP1+8),a             ;null terminate string in OP1
  B_CALL PutS              ;Print Name 
  ret
InRam:
  push de                 ;store where data starts
  ld hl,0003h
  ADD HL,DE               ;+1 for data valid flag, +2 for data size
  ld de,OP1               ;to what
  ld bc,4                 ;how many
  ldir                    ;load 4 bytes (id)
  Call CheckValidVar      ;check if app var is valid
  pop de                  ;restore where data starts
  ld hl,0008h
  ADD HL,DE               ;+1 for data valid flag,+2 for size,+4 for id,+1 for data type byte
  ld de,OP1               ;to what
  ld bc,8                 ;how many
  ldir                    ;load name
  ld hl,OP1        
  ld a,0
  ld (OP1+8),a            ;null terminate string
  B_CALL PutS             ;Print Name 
  ret
;Addition of HL and DE accounting for page breaks (copied from developmental documentation)
;used for archive offset modification
AddHLDERom:
  ADD HL,DE
  BIT 7,H
  RET Z
  INC B
  RES 7,H
  SET 6,H
  RET

;alternate search routine used for names that have spaces added to the end so each name is 8 charcters long
TryAgain:
  B_CALL OP3ToOP1  
  B_CALL ConvOP1       ;letters typed into de
  ld hl,0008h          ;de = 8
  B_CALL CpHLDE        ;compare letters typed in to 8
  jr Z,ProgramNotFound ;if name already full jump to error handler  
  ld hl,OP4            ;hl = pointer to OP4
  ADD HL,DE            ;where to start with spaces
SpaceLoop:
  inc hl               ;increase letters typed
  ld (hl),20h          ;load space to OP2
  ld de,OP4+8          ;de = pointer to OP4+8
  B_CALL CpHLDE        ;compare end of name and current position
  jr NZ,SpaceLoop      ;if not there add another space
  B_CALL OP4ToOP1      ;program name to OP1
  ld a,05h
  ld (OP1+0),a         ;makes OP1 signify a program 
  B_CALL ChkFindSym    ;search for program completed with spaces
  jr C,ProgramNotFound ;if still not found jump to error handler
  jp ProgramFound      ;if found jump to program found

;checks the 4 byte id of an app var to assure it is valid
CheckValidVar:
  ld de,(OP1+0)
  ld d,0                ;de = first byte of id
  ld hl,0042h           ;hl = "B"
  B_CALL CpHLDE         ;compare id byte and letter
  jr NZ, InvalidAppVar  ;if not equal jump to error handler
  ld de,(OP1+1)
  ld d,0                ;de = second byte of id
  ld hl,004Bh           ;hl = "K"
  B_CALL CpHLDE         ;compare id byte and letter
  jr NZ, InvalidAppVar  ;if not equal jump to error handler
  ld de,(OP1+2)
  ld d,0                ;de = third byte of id
  ld hl,0055h           ;hl = "U"
  B_CALL CpHLDE         ;compare id byte and letter
  jr NZ, InvalidAppVar  ;if not equal jump to error handler
  ld de,(OP1+3)
  ld d,0                ;de = fourth byte of id
  ld hl,0050h           ;hl = "P"
  B_CALL CpHLDE         ;compare id byte and letter
  jr NZ, InvalidAppVar  ;if not equal jump to error handler
  ret

RomBkup1: DB  15h,52h,4Fh,4Dh,42h,4Bh,55h,50h,31h  ;ROMBKUP1
RomBkup2: DB  15h,52h,4Fh,4Dh,42h,4Bh,55h,50h,32h  ;ROMBKUP2
RomBkup3: DB  15h,52h,4Fh,4Dh,42h,4Bh,55h,50h,33h  ;ROMBKUP3
RomBkup4: DB  15h,52h,4Fh,4Dh,42h,4Bh,55h,50h,34h  ;ROMBKUP4
RomBkup5: DB  15h,52h,4Fh,4Dh,42h,4Bh,55h,50h,35h  ;ROMBKUP5
RomBkup6: DB  15h,52h,4Fh,4Dh,42h,4Bh,55h,50h,36h  ;ROMBKUP6
RomBkup7: DB  15h,52h,4Fh,4Dh,42h,4Bh,55h,50h,37h  ;ROMBKUP7
RomBkup8: DB  15h,52h,4Fh,4Dh,42h,4Bh,55h,50h,38h  ;ROMBKUP8
AppVar4byteId: .asciz "BKUP"

Restore: 
  Call WhichOne             ;app var in OP1,OP5
  B_CALL ChkFindSym         ;find app var
  jr C,InvalidAppVar        ;if doesn't exist jump to error handler
  jp CreatProg              ;jump to create program

;writes data to app var
WriteProg:
  B_CALL ChkFindSym         ;find app var
  inc de
  inc de                    ;+2 for size bytes
  push de                   ;save data position
  B_CALL OP5ToOP1           ;program name store in OP1
  B_CALL ChkFindSym         ;find program
  ld a,b
  or a                      ;test for archive status
  jr Z,InRam3               ;jump if in Ram
  ld h,d
  ld l,e                    ;hl = start of variable
  ld de,0024h               ;3 bytes + 15 bytes for symbol table entry + 3 bytes + 4 byte + 9 byte name + 2 byte size
  CALL AddHLDERom           ;calculate page and offset
  pop de                    ;restore data position
  ld bc,(OP6+0)             ;load size of program into bc
  B_CALL FlashToRam         ;copy program data
  jp Menu
InRam3:
  ld h,d
  ld l,e                   ;hl = start of variable
  ld de,0012h
  add hl,de                ;3 bytes + 4 bytes + 9 byte name + 2 byte size
  pop de                   ;restore data position
  ld bc,(OP6+0)            ;load size of program into bc
  ldir                     ;copy program data
  jp Menu  

;creates program in ram
CreatProg:
  B_CALL ChkFindSym        ;find app var
  ld a,b
  or a                     ;get archived status
  jr Z,InRam2              ;jump if in Ram
  ld h,d
  ld l,e                   ;hl = start of variable
  push de                  ;save start of variable
  ld c,a                   ;c = page
  push bc                  ;save page
  ld de,0022h              ;3 bytes + 15 bytes for symbol table entry + 3 bytes + 4 bit id + 9 name
  CALL AddHLDERom          ;calculate page and offset
  B_CALL LoadDEIndPaged    ;first 2 bytes of data (Size) to DE 
  pop bc                   ;restore page
  ld b,c                   ;page to b
  pop hl                   ;restore start of variable to hl
  push de                  ;save size
  ld de,0019h              ;3 bytes + 15 bytes for symbol table entry + 3 bytes + 4 bit id
  CALL AddHLDERom          ;calculate page and offset
  ld a,b                   ;page to a
  ld de,OP1                ;copy to OP1
  ld bc,9                  ;copy 9
  B_CALL FlashToRam        ;next 9 bytes of data (sign byte + name)
  B_CALL ChkFindSym        ;look for program to be created
  jr nc,ProgramStillExists ;if it already exists jump to error handler
  pop de                   ;restore size
  ld (OP6+0),de            ;load size into OP6
  push de                  ;save size
  ld h,d
  ld l,e                   ;hl = size
  ld de,00F
  add hl,de                ;+15 for symboltable entry
  B_CALL EnoughMem         ;check if enough memory to create prog
  jr c,NotEnoughMem        ;jump to error handler if not
  ld hl,(OP1+0)            ;data type to hl
  ld h,0
  ld de,05h                ;de = normal program
  B_CALL CpHLDE            ;compare program data type and normal program
  jr NZ, Creatprot         ;if protected progam jump to protected progam creator
  pop hl                   ;restore size to hl                  
  B_CALL CreateProg        ;create the program
  B_CALL OP4ToOP1          ;program name to OP1
  jp WriteProg             ;jump to add data to program
Creatprot:                 ;creates a protected program
  pop hl                   ;restore size to hl                
  B_CALL CreateProtProg    ;create the protected program
  B_CALL OP4ToOP1          ;program name to OP1
  jp WriteProg             ;jump to add data to program
InRam2:
  push de                  ;store where data starts
  ld hl,0010h
  ADD HL,DE                ;3 bytes + 4 byte id + 9 name
  ld de,OP1                ;copy to OP1
  ld bc,2                  ;copy 2 bytes
  ldir                     ;size into OP1
  ld hl,(OP1+0)            ;load size into hl
  pop de                   ;restore where data starts  
  push hl                  ;save program size
  ld hl,0007h
  add hl,de                ;+1 for data valid flag,+2 for size,+4 for id
  ld de,OP1                ;to what
  ld bc,9                  ;how many
  ldir                     ;load 9 bytes  (sign byte + name)
  B_CALL ChkFindSym        ;find program
  jr nc,ProgramStillExists ;if program already exists jump to error handler
  pop hl                   ;restore program size
  ld (OP6+0),hl            ;store program size to OP6
  push hl                  ;save program size
  ld de,000Fh
  add hl,de                ;+15 for symboltable entry
  ;ld d,h
  ;ld e,l
  B_CALL EnoughMem         ;check if there is enough memory to create program
  jr c,NotEnoughMem        ;jump to error handler if there isn't
  ld hl,(OP1+0)
  ld h,0                   ;hl = program data type
  ld de,05h                ;de = normal program
  B_CALL CpHLDE            ;compare program data type and normal program
  jr NZ, Creatprot2        ;if protected program jump to creat protected program
  pop hl                   ;restore size to hl
  B_CALL CreateProg        ;create normal program
  B_CALL OP4ToOP1          ;program name to OP1
  jp WriteProg             ;jump to add data to program
Creatprot2:
  pop hl                   ;restore size to hl
  B_CALL CreateProtProg    ;create protected program
  B_CALL OP4ToOP1          ;program name to OP1
  jp WriteProg             ;jump to add data to program

;Error Handlers
ProgramNotFound:
  B_CALL ClrLCDFull        ;Clear the screen
  ld a,0                    ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld (curRow),a            ;Will start printing on first row
  ld hl, ProgramNo        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS                  ;Print the string
  ld hl, StingT        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS                  ;Print the string
  ld a,0                    ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld a,1                    ;A=1
  ld (curRow),a            ;Will start printing in left column
  ld hl, Found        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS                  ;Print the string 
  B_CALL GetKey
  jp Menu

ProgramNo .asciz "Program no" ;Null-terminated string
StingT .asciz "t"
Found .asciz "Found"

ProgramStillExists:
  B_CALL ClrLCDFull        ;Clear the screen
  ld a,0                    ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld (curRow),a            ;Will start printing on first row
  ld hl, Program        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS                  ;Print the string
  ld a,0                    ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld a,1                    ;A=1
  ld (curRow),a            ;Will start printing in left column
  ld hl, StillExist        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS                  ;Print the string
  ld hl, StringS         ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS                  ;Print the string 
  B_CALL GetKey
  jp Menu

StillExist .asciz "Still Exist" ;Null-terminated string
StringS  .asciz "s"

BattsLow:
  B_CALL ClrLCDFull        ;Clear the screen
  ld a,0                    ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld (curRow),a            ;Will start printing on first row
  ld hl, Batteries        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS                  ;Print the string
  ld a,0                    ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld a,1                    ;A=1
  ld (curRow),a            ;Will start printing on second row
  ld hl, StringLow        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS                  ;Print the string
  B_CALL GetKey
  jp Menu

Batteries .asciz "Batteries" ;Null-terminated string
StringLow .asciz "Low"

InvalidAppVar:
  B_CALL ClrLCDFull        ;Clear the screen
  ld a,0                    ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld (curRow),a            ;Will start printing on first row
  ld hl, Invalid        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS                  ;Print the string
  ld a,0                    ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld a,1                    ;A=1
  ld (curRow),a            ;Will start printing on second row
  ld hl, AppVar        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS                  ;Print the string
  B_CALL GetKey
  jp Menu

Invalid .asciz "Invalid" ;Null-terminated string
AppVar .asciz "AppVar"
  
ProgramArchived:
  B_CALL ClrLCDFull        ;Clear the screen
  ld a,0                    ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld (curRow),a            ;Will start printing on first row
  ld hl, Program        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS                  ;Print the string
  ld a,0                    ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld a,1                    ;A=1
  ld (curRow),a            ;Will start printing on second row
  ld hl, Archived        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS                  ;Print the string
  B_CALL GetKey
  jp Menu

Program .asciz "Program" ;Null-terminated string
Archived .asciz "Archived"

NotEnoughMem:
  B_CALL ClrLCDFull        ;Clear the screen
  ld a,0                    ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld (curRow),a            ;Will start printing on first row
  ld hl, NotEnough        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS                  ;Print the string
  ld a,0                    ;A=0
  ld (curCol),a            ;Will start printing in left column
  ld a,1                    ;A=1
  ld (curRow),a            ;Will start printing on second row
  ld hl, Memory        ;HL points to null-terminated string in ROM
  ld de, OP1         
  B_CALL StrCopy       
  ld hl, OP1             
  B_CALL PutS                  ;Print the string
  B_CALL GetKey
  jp Menu

NotEnough .asciz "Not Enough" ;Null-terminated string
Memory .asciz "Memory"

ExitApp:
  B_CALL ReloadAppEntryVecs ;loads monitor vectors to App Loader
  B_JUMP JForceCmdNoChar    ;exits app

SHeader  .asciz "Program Bac" ;Null-terminated string
SHeader2 .asciz "k Up"
SMenu1   .asciz "1. Backup"
SMenu2   .asciz "2. Restore"
SMenu3   .asciz "3. Exit"
SNameOfPro  .asciz "Name of Pro"
Sgram  .asciz "gram"
StoBackUp  .asciz "to Back Up"
SFillToEnd  .asciz "Fill To End"
SWith  .asciz "With"
SSpaces?  .asciz "Spaces?"
SYes  .asciz "1. Yes"
SNo  .asciz "2. No"

